Attribute VB_Name = "modTnsUpdate"
Option Explicit

Private Const HKEY_CURRENT_USER = &H80000001
Private Const HKEY_LOCAL_MACHINE = &H80000002
Private Const HKEY_CLASSES_ROOT = &H80000000
Private Const HKEY_USERS = &H80000003
Private Const HKEY_PERFORMANCE_DATA = &H80000004
Private Const STANDARD_RIGHTS_READ = &H20000
Private Const KEY_QUERY_VALUE& = &H1
Private Const KEY_ENUMERATE_SUB_KEYS& = &H8
Private Const KEY_NOTIFY& = &H10
Private Const SYNCHRONIZE = &H100000
Private Const KEY_READ& = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
Private Const STANDARD_RIGHTS_WRITE = &H20000
Private Const KEY_SET_VALUE& = &H2
Private Const KEY_CREATE_SUB_KEY& = &H4
Private Const KEY_WRITE& = ((STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY) And (Not SYNCHRONIZE))


Private Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function RegOpenKeyEx& Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long)
Private Declare Function RegQueryValueEx& Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long)
Private Declare Function RegCloseKey& Lib "advapi32.dll" (ByVal hKey As Long)

Public Function OracleConfig(ByVal strTask As String) As Integer
Dim strClientFile(3000) As String
Dim intNumClientLines As Integer
Dim strClientORAFile As String
Dim strSourceORAFile As String
Dim strConfigName As String
Dim strOverwrite As String
Dim blnOverwrite As Boolean
Dim strDriverKey As String
Dim blnOK As Boolean
Dim blnGoForIt As Boolean
Dim strTemp As String
Dim strTemp2 As String
Dim strTemp3 As String
Dim blnFound As Boolean
Dim intSlashPos As Integer
Dim strBuffer As String
Dim blnStartFound As Boolean
Dim blnEndFound As Boolean
Dim strMaster(3000) As String
Dim intMasterLineCount As Integer
Dim dtmDateTM As Date
Dim dtmDateTM2 As Date
Dim i As Integer
Dim intStart As Integer
Dim intEnd As Integer
Dim blnFoundConnectData As Boolean
Dim intConnectData As Integer
Dim strForce16Bit As String
Dim blnForce16Bit As Boolean
Dim intODBCPos As Integer
Dim strOra805 As String
Dim bolOra805 As Boolean
Dim strWindowsDir As String
Dim lngReturn As Long
Dim strDelete As String
Dim blnDelete As Boolean
Dim intReturn As Integer


  
  
  strWindowsDir = Space(100)
  lngReturn = GetWindowsDirectory(strWindowsDir, 100)
  strWindowsDir = Left(strWindowsDir, lngReturn)
  
  ' Read the SourceORAFile from the Task...
  If (Right(App.Path, 1) = "\") Then
      strSourceORAFile = App.Path & "tnskelton.ora"   ' without the slash.
    Else
      strSourceORAFile = App.Path & "\tnskelton.ora"   ' use the 'Current' directory.
    End If
    
  ' Read the ConfigName from the Task...
  strConfigName = ReadIniSetting(m_strIniFile, strTask, "ConfigName", 100, "")
  If (Len(Trim(strConfigName)) = 0) Then
    MsgBox "ConfigName not specified for task '" & strTask & "'", vbCritical, "Critical Problem:"
    End
  End If

  ' Read the DriverKey from the Task...
  strDriverKey = ReadIniSetting(m_strIniFile, strTask, "DriverKey", 100, "")
  If (Len(Trim(strDriverKey)) = 0) Then
    MsgBox "DriverKey not specified for task '" & strTask & "'", vbCritical, "Critical Problem:"
    End
  End If

  ' Read the Force16Bit flag from the Task...
  strForce16Bit = ReadIniSetting(m_strIniFile, strTask, "Force16Bit", 100, "")
  If (Len(Trim(strForce16Bit)) = 0) Then
    strForce16Bit = "No"
  End If
  If (Left(UCase(strForce16Bit), 1) = "Y") Then
    blnForce16Bit = True
  Else
    blnForce16Bit = False
  End If
  
  'Read the Oracle805 flag from the task
  strOra805 = ReadIniSetting(m_strIniFile, strTask, "Oracle805", 100, "")
  If (Len(Trim(strOra805)) = 0) Then
      strOra805 = "No"
  End If

  ' Read the Overwrite flag from the Task...
  strOverwrite = ReadIniSetting(m_strIniFile, strTask, "Overwrite", 300, "")
  If (UCase(strOverwrite) = "YES") Then
    blnOverwrite = True
  Else
    blnOverwrite = False
  End If
  
   strDelete = ReadIniSetting(m_strIniFile, strTask, "Delete", 300, "")
  If (UCase(Trim(strDelete)) = "YES") Then
    blnDelete = True
  Else
    blnDelete = False
  End If
  
  ' obtain the Driver DLL file with complete path...
  If blnForce16Bit Then
    strTemp = strWindowsDir + "\ODBCINST.INI"
    
    strTemp2 = ReadIniSetting(strTemp, strDriverKey, "Driver", 300, "")
  Else
    strTemp = "Software\ODBC\ODBCINST.INI\" & strDriverKey
    blnOK = Registry_GetKeyValue(HKEY_LOCAL_MACHINE, strTemp, "Driver", strTemp2)
    If (Not blnOK) Then
      MsgBox "Could not find ODBC Driver Key " & strDriverKey & " for Task " & strTask, vbCritical, "Error:"
      OracleConfig = -1
      Exit Function
    End If
  End If
  
  ' determine the path to the tnsnames.ora file based on the DLL path...
  ' perform a search for the location of the "odbc" in the string,
  ' and then use all of it to the left of the odbc for the base path...
  ' Typical driver string being searched: c:\orawin95\odbc250\SQO32_73.DLL
  '                                    or c:\orawin\odbc\xyz.DLL
  '     or even those district II folks:  c:\win16app\orant\odbc\xyz.DLL
  'James 1/4/2000
  'With the onset of Oracle 8 some folder names has changed in an effort to maintain
  'backwards compatablity the old logic is modify with an if statement to cause a jump
  'to the new logic.
    
    
 If strDriverKey <> "Oracle ODBC Driver" Then
    strTemp2 = UCase(strTemp2)
    intODBCPos = InStr(strTemp2, "ODBC")
    If (intODBCPos = 0) Then
      MsgBox "Error parsing DLL Path in Task " & strTask & ":" & vbCrLf & strTemp2, vbCritical, "Error:"
      OracleConfig = -1
      Exit Function
    End If
    
    strClientORAFile = Left(strTemp2, intODBCPos - 1) & "Network\Admin\tnsnames.ora"
 Else
    strTemp2 = UCase(strTemp2)
    intODBCPos = InStr(strTemp2, "BIN")
    If (intODBCPos = 0) Then
      MsgBox "Error parsing DLL Path in Task " & strTask & ":" & vbCrLf & strTemp2, vbCritical, "Error:"
      OracleConfig = -1
      Exit Function
    End If
    
    On Error Resume Next
      Err.Clear
      intReturn = GetAttr(Left(strTemp2, intODBCPos - 1) & "Net80\Admin") And vbDirectory
      'MsgBox Err.Number & Err.Description
      
      If intReturn = 0 Then
        bolOra805 = False
      Else
        bolOra805 = True
      End If
      Err.Clear
    On Error GoTo 0
      
    If bolOra805 Then
        strClientORAFile = Left(strTemp2, intODBCPos - 1) & "Net80\Admin\tnsnames.ora"
    Else
        strClientORAFile = Left(strTemp2, intODBCPos - 1) & "Network\Admin\tnsnames.ora"
    End If
 
 End If
 'MsgBox strClientORAFile
 
' Check to see if there is not yet a TNSNAMES.ORA file present...
' temporarily REPLACE the user's ORA file because of previous bugs...
  If (Not FileExists(strClientORAFile)) Then
    FileCopy strSourceORAFile, strClientORAFile
    SetAttr strClientORAFile, vbNormal
    
    OracleConfig = 1
    Exit Function
  End If
  
  ' make a safety backup of the TNSNAMES.ORA File...
  
  strTemp3 = Left(strClientORAFile, Len(strClientORAFile) - 4) & ".saf"
  FileCopy strClientORAFile, strTemp3
  SetAttr strTemp3, vbNormal
    
  
  
  ' read in the complete current contents of the user's tnsnames.ora file
  ' into the buffer array...
  On Error Resume Next
  Open strClientORAFile For Input As #2
  If (Err.Number <> 0) Then
    MsgBox "Error opening " & strClientORAFile & " in Task " & strTask, vbCritical, "Error:"
    OracleConfig = -1
    Exit Function
  End If
  On Error GoTo 0
  
  ' read in the entire file into a memory based buffer array...
  intNumClientLines = 0
  Do
    Line Input #2, strBuffer
    If (Not EOF(2)) Then
      intNumClientLines = intNumClientLines + 1
      strClientFile(intNumClientLines) = strBuffer
    End If
  Loop Until EOF(2)
  ' bug fix... include the EOF line in the buffer array...
  intNumClientLines = intNumClientLines + 1
  strClientFile(intNumClientLines) = strBuffer
  
  Close #2
  
  ' If not in Overwrite mode, scan down through the current Oracle Config
  ' file to see if the entry is already present...
  blnGoForIt = True
  If (Not blnOverwrite) Then
      For i = 1 To intNumClientLines
        strTemp = UCase(strConfigName)
        If (InStr(UCase(strClientFile(i)), strTemp) > 0) Then
          blnGoForIt = False
          Exit For
        End If
      Next
  End If
    
  If (Not blnGoForIt) Then
    OracleConfig = 1   ' success without overwriting.
    Exit Function
  End If
  
  If Not blnDelete Then
  
     ' Open the master tnsnames.ora file to read in the configuration...
     On Error Resume Next
     Open strSourceORAFile For Input As #3
     If (Err.Number <> 0) Then
       MsgBox "Could not open master Oracle Config file for task " & strTask, vbCritical, "Error:"
       OracleConfig = -1
       Exit Function
     End If
     On Error GoTo 0
     
     ' scan down the file until we find the configuration entry...
     blnStartFound = False
     strTemp = UCase(Trim(strConfigName))
     Do While Not EOF(3)
       Line Input #3, strBuffer
       If (InStr(UCase(Trim(strBuffer)), strTemp) > 0) Then
         blnStartFound = True
         Exit Do
       End If
     Loop
     If (Not blnStartFound) Then
       MsgBox "Could not find section " & strConfigName & " in master Oracle Config file for task " & strTask, vbCritical, "Error:"
       OracleConfig = -1
       Exit Function
     End If
     
     ' skip down in the file until we find the CONNECT_DATA keyword...
     intMasterLineCount = 1
     strMaster(intMasterLineCount) = strBuffer
     Do
       Line Input #3, strBuffer
       If (Not EOF(3)) Then
         intMasterLineCount = intMasterLineCount + 1
         strMaster(intMasterLineCount) = strBuffer
       End If
     Loop Until (EOF(3)) Or (InStr(1, strBuffer, "CONNECT_DATA", 1) > 0)
     
     ' skip down in the file until we find the next .world or EOF...
     Do
       Line Input #3, strBuffer
       If (Not EOF(3)) And (InStr(1, strBuffer, ".world", 1) = 0) And _
          (Len(Trim(strBuffer)) > 0) Then
         intMasterLineCount = intMasterLineCount + 1
         strMaster(intMasterLineCount) = strBuffer
       End If
     Loop Until (EOF(3)) Or (InStr(1, strBuffer, ".world", 1) > 0)
    
     Close #3

End If

  ' now scan down through the client buffer array looking for the
  ' matching section...
  blnStartFound = False
  For i = 1 To intNumClientLines
    If (InStr(UCase(strClientFile(i)), UCase(Trim(strConfigName))) > 0) Then
      blnStartFound = True
      intStart = i
      Exit For
    End If
  Next
  If blnStartFound Then
    ' skip down to the CONNECT_DATA line...
    blnEndFound = False
    For i = (intStart) To intNumClientLines
      If (InStr(1, strClientFile(i), "CONNECT_DATA", 1) > 0) Then
        intConnectData = i
        Exit For
      End If
    Next
    ' it was found, scan down to find the bottom of the section...
    For i = (intConnectData + 1) To intNumClientLines
      If (InStr(1, strClientFile(i), ".world", 1) > 0) Then
        blnEndFound = True
        intEnd = i - 1
        Exit For
      End If
    Next
    If (Not blnEndFound) Then
      intEnd = intNumClientLines
    End If
    
    ' now comment out all the old lines...
    For i = intStart To intEnd
      strClientFile(i) = "^^^"
    Next
  End If
    
  ' now copy the configuration section to the bottom of the file...
  If Not blnDelete Then
  
    For i = 1 To intMasterLineCount
      intNumClientLines = intNumClientLines + 1
      strClientFile(intNumClientLines) = strMaster(i)
    Next
    
  End If
  
  ' now write back out contents of the updated buffer array...
  On Error Resume Next
  Open strClientORAFile For Output As #4
  If (Err.Number <> 0) Then
    MsgBox "Could not write to file " & strClientORAFile & " for Task " & strTask, vbCritical, "Error:"
    OracleConfig = -1
    Exit Function
  End If
  On Error GoTo 0

  ' read in the entire file into a memory based buffer array...
  For i = 1 To intNumClientLines
    If (Left(strClientFile(i), 3) <> "^^^") Then
      Print #4, strClientFile(i)
    End If
  Next
  Close #4

  OracleConfig = 1  ' success.
End Function

Private Function FileExists(fname As String) As Boolean
Dim ls_Result As String
Dim strMsg As String

  On Error Resume Next
  Err.Clear
  
  ' check for the existence of a file...
  ls_Result = Dir(fname, vbNormal + vbSystem + vbReadOnly + vbHidden + vbArchive)
  If (Err.Number <> 0) Then
    strMsg = "Error # " & Str(Err.Number) & " Calling Dir in FileExists function. Generated by " _
           & Err.Source & Chr(13) & Err.Description
    MsgBox strMsg, , "OnTheFly Copy Error:", Err.HelpFile, Err.HelpContext
  End If
  
  If (Len(ls_Result) = 0) Then
    FileExists = False
  Else
    FileExists = True
  End If
End Function

Public Function ReadIniSetting(ByVal strFile As String, _
                               ByVal strSection As String, _
                               ByVal strKey As String, _
                               ByVal intLength As Integer, _
                               ByVal strDefault As String) As String
Dim lngReturn As Long
Dim strAnswer As String

  strAnswer = Space(intLength)
  lngReturn = GetPrivateProfileString(strSection, strKey, strDefault, strAnswer, intLength, strFile)
  ReadIniSetting = Left(strAnswer, lngReturn)
End Function

Private Function Registry_GetKeyValue(ByVal KeyRoot As Long, _
                                      ByVal KeyName As String, _
                                      ByVal ValueName As String, _
                                      ByRef ValueData As String) As Boolean
Dim lngReturn As Long
Dim lngHandle As Long
Dim strValue As String
Dim lngLength As Long
Dim lngType As Long
Dim strValName As String
Dim strKeyName As String
Dim lngRoot As Long
  
' Why doing it the following way directly from VB does not work I may never know!!
  ' Open the Registry Key specified...
  strKeyName = KeyName & Chr$(0)
  lngReturn = RegOpenKeyEx(KeyRoot, ByVal KeyName, 0, KEY_READ, lngHandle)
  If (lngReturn <> 0) Then
    ' do not abort, simply return an empty string...
    ValueData = ""
    Registry_GetKeyValue = True
    Exit Function
  End If

  ' Now read the value of the Registry value...
  lngLength = 500
  strValue = String(lngLength, 0)
  lngType = 0
  strValName = ValueName & Chr$(0)

  lngReturn = RegQueryValueEx(lngHandle, ByVal strValName, 0, lngType, ByVal strValue, lngLength)
  If (lngReturn <> 0) Then
    ' do not abort, simply return an empty string...
    ValueData = ""
    Registry_GetKeyValue = True
    Exit Function
  End If
  strValue = Left(strValue, lngLength - 1)

  ' Now Close the Registry Key...
  lngReturn = RegCloseKey(lngHandle)
  If (lngReturn <> 0) Then
    MsgBox "Error Closing Registry Key " & KeyName
    Registry_GetKeyValue = False
    Exit Function
  End If
  
  Registry_GetKeyValue = True
  ValueData = strValue
  
End Function
